CDECK  ID>, HWD4ME.
*CMZ :-        -20/10/99  09:46:43  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWD4ME(ID,ITYPE1,ITYPE2,IMODE)
C-----------------------------------------------------------------------
C     Subroutine to perform the four body Higgs decays
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER IMODE,I,J,ID,IDP(4+NDIAGR),ITYPE(2),NTRY,ITYPE1,ITYPE2
      DOUBLE PRECISION A,B,MS,MWD,M,M2,WGT,HWRUNI,BRW(6),BRZ(12),
     &     HWUPCM,WMAX,WSUM,WSSUM,MR,PRE,TEMP,HWRGEN,WTMAX,P(5,5)
      EXTERNAL HWRUNI,HWUPCM,HWRGEN
      COMMON/HWD4BY/A(2),B(2),MS(2),MWD(2),MR(2),M(5),M2(5),P,IDP
      SAVE BRW,BRZ
      DATA BRW/0.321D0,0.321D0,0.000D0,0.108D0,0.108D0,0.108D0/
      DATA BRZ/0.154D0,0.120D0,0.154D0,0.120D0,0.152D0,0.000D0,
     &         0.033D0,0.067D0,0.033D0,0.067D0,0.033D0,0.067D0/
      ITYPE(1) = ITYPE1
      ITYPE(2) = ITYPE2
      WTMAX = WT4MAX(ITYPE(1),ITYPE(2),IMODE)
      PRE=P4MODE(ITYPE(1),ITYPE(2),IMODE)
C--compute the masses of external particles for the decay mode
      DO I=1,2
C--couplings and masses of the internal particles
        A(I) = A4MODE(I,ITYPE1,IMODE)
        B(I) = B4MODE(I,ITYPE2,IMODE)
        MR(I)  = RMASS(I4MODE(I,IMODE))
        MS(I)  = MR(I)**2
        IF(I4MODE(I,IMODE).EQ.200) THEN
          MWD(I) = MR(I)*GAMZ
        ELSE
          MWD(I) = MR(I)*GAMW
        ENDIF
        IDP(5+I) = I4MODE(I,IMODE)
C--id's of outgoing particles
        IF(I4MODE(I,IMODE).EQ.200) THEN
          IDP(2*I  ) = ITYPE(I)
          IF(ITYPE(I).GT.6) IDP(2*I) = IDP(2*I)+114
          IDP(2*I+1) = IDP(2*I)+6
        ELSE
          IDP(2*I  ) = 2*ITYPE(I)-1
          IF(ITYPE(I).GT.3) IDP(2*I) = IDP(2*I)+114
          IDP(2*I+1) = IDP(2*I)+7
          IF(I4MODE(I,IMODE).EQ.198) THEN
            J          = IDP(2*I  )+6
            IDP(2*I) = IDP(2*I+1)-6
            IDP(2*I+1) = J
          ENDIF
        ENDIF
      ENDDO
      IDP(1) = IDK(ID4PRT(IMODE))
      DO 1 I=1,5
      M(I) = RMASS(IDP(I))
 1    M2(I) = M(I)**2
      IF(M(1).LT.M(2)+M(3)+M(4)+M(5).OR.MR(1).LT.M(2)+M(3).OR.
     &     MR(2).LT.M(4)+M(5)) RETURN
      IF(IPRINT.GE.2.AND..NOT.GENEV)
     &        WRITE(6,3000) RNAME(IDP(6)),RNAME(IDP(2)),RNAME(IDP(3)),
     &                      RNAME(IDP(7)),RNAME(IDP(4)),RNAME(IDP(5))
C--compute the width and maximum weight if initialising
      IF(.NOT.GENEV) THEN
        WMAX  = ZERO
        WSUM  = ZERO
        WSSUM = ZERO
        DO I=1,NSEARCH
          CALL HWD4M0(1,WGT)
          WGT = WGT*PRE
          IF(WGT.GT.WMAX) WMAX = WGT
          WSUM = WSUM+WGT
          WSSUM = WSSUM+WGT**2
          IF(WGT.LT.ZERO) CALL HWWARN('HWD4ME',500)
        ENDDO
        WSUM = WSUM/DBLE(NSEARCH)
        WSSUM = MAX(ZERO,WSSUM/DBLE(NSEARCH)-WSUM**2)
        WSSUM = SQRT(WSSUM/DBLE(NSEARCH))
        IF(IPRINT.GE.2) WRITE(6,3010) WSUM,WSSUM
        IF(IPRINT.GE.2) WRITE(6,3020) WMAX
        TEMP = BRFRAC(ID4PRT(IMODE))*HBAR/RLTIM(IDK(ID4PRT(IMODE)))
        DO J=1,2
          IF(I4MODE(J,IMODE).EQ.200) THEN
            TEMP = TEMP*BRZ(ITYPE(J))
          ELSE
            TEMP = TEMP*BRW(ITYPE(J))
          ENDIF
        ENDDO
        IF(IPRINT.GE.2) WRITE(6,3030) WSUM/TEMP,WSSUM/TEMP
C--set up the maximum weight
        WT4MAX(ITYPE(1),ITYPE(2),IMODE) = WMAX
      ELSE
C--generate a configuation
        NTRY = 0
        IF(SYSPIN.AND.NSPN.NE.0) CALL HWWARN('HWD4ME',501)
 100    NTRY = NTRY+1
        CALL HWD4M0(ID,WGT)
        WGT = WGT*PRE
        IF(HWRGEN(0)*WTMAX.GT.WGT.AND.NTRY.LT.NSNTRY) GOTO 100
        IF(NTRY.GE.NSNTRY) THEN
          CALL HWWARN('HWD4ME',100)
          GOTO 999
        ENDIF
      ENDIF
 3000 FORMAT(/'  FOLLOWED BY ',A8,' --> ',A8,' ',A8,' AND ',
     &                         A8,' --> ',A8,' ',A8)
 3010 FORMAT('            PARTIAL WIDTH  = ',G12.4,' +/- ',G12.4)
 3020 FORMAT('            MAXIMUM WEIGHT = ',E12.4)
 3030 FORMAT('     RATIO TO ISAJET VALUE = ',G12.4,' +/- ',G12.4)
 999  RETURN
      END
