CDECK  ID>, HWHGB3.
*CMZ :-        -02/04/01  12.11.55  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWHGB3(HCS,IDP,PHOTON)
C-----------------------------------------------------------------------
C     ZZ cross section in hadron hadron
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      DOUBLE PRECISION AMP(2),RCS,HCS,HWRGEN,DIST(2),S34,S56,CFAC,
     &     MW2,MZ2,GMW,GMZ,G(4,2),EE(4),CKM2(12),RF(2),LF(2),TAUI(2),
     &     CSW,CFAC1
      DOUBLE COMPLEX ZH,ZCH,ZD,P34,P56,Z34,Z56,Z1,ZAMP(8),S134,S156,
     &        HWHEW4,TAMP,Z0,AMPT(2,2,2,2),CP
      INTEGER I,P1,P2,P3,IDP(10),I2,MAPZ(4,3),I1,ID(2),O(2)
      EXTERNAL HWHEW4,HWRGEN
      LOGICAL PHOTON
      COMMON/HWHEWQ/ZH(8,8),ZCH(8,8),ZD(8,8)
      COMMON /HWHGBC/ MW2,MZ2,GMW,GMZ,G,EE,CKM2,RF,LF,TAUI,CSW,CFAC1
      PARAMETER(Z0=(0.0D0,0.0D0),Z1=(0.0D0,1.0D0))
      SAVE AMP,ID,AMPT
      SAVE MAPZ,O
      DATA MAPZ/1,2,121,122,3,4,123,125,5,6,124,126/
      DATA O/2,1/
C--initialisation
      IF(GENEV) THEN
         RCS = HCS*HWRGEN(0)
      ELSE
C--Identitiys of the decay prodcucts (d=1,u=2,e=3,nu=4)
        DO I=1,2
          ID(I) = IDP(1+2*I)
          IF(ID(I).GE.121) ID(I) = ID(I)-114
          ID(I) = MOD(ID(I)+1,2)+2*INT((ID(I)-1)/6)+1
        ENDDO
C--the various propagators we need
        S34 = TWO*DBLE(ZD(3,4))
        S56 = TWO*DBLE(ZD(5,6))
        Z34 = ONE/(S34-MZ2+Z1*GMZ)
        Z56 = ONE/(S56-MZ2+Z1*GMZ)
        IF(PHOTON) THEN
          P34 = Z34*(S34-MZ2)/S34
          P56 = Z56*(S56-MZ2)/S56
        ELSE
          P34 = Z0
          P56 = Z0
        ENDIF
        S134 = HALF/(ZD(1,3)+ZD(1,4)+ZD(3,4))
        S156 = HALF/(ZD(1,5)+ZD(1,6)+ZD(5,6))
C--Now calculate the amplitudes
        ZAMP(1)=HWHEW4(1,2,3,4,5,6)*S134+HWHEW4(1,2,5,6,3,4)*S156
        ZAMP(2)=HWHEW4(1,2,4,3,5,6)*S134+HWHEW4(1,2,5,6,4,3)*S156
        ZAMP(3)=HWHEW4(1,2,3,4,6,5)*S134+HWHEW4(1,2,6,5,3,4)*S156
        ZAMP(4)=HWHEW4(1,2,4,3,6,5)*S134+HWHEW4(1,2,6,5,4,3)*S156
        ZAMP(5)=HWHEW4(2,1,3,4,5,6)*S156+HWHEW4(2,1,5,6,3,4)*S134
        ZAMP(6)=HWHEW4(2,1,4,3,5,6)*S156+HWHEW4(2,1,5,6,4,3)*S134
        ZAMP(7)=HWHEW4(2,1,3,4,6,5)*S156+HWHEW4(2,1,6,5,3,4)*S134
        ZAMP(8)=HWHEW4(2,1,4,3,6,5)*S156+HWHEW4(2,1,6,5,4,3)*S134
C--Now the amplitudes squared for the process
        DO I=1,2
          TAMP = Z0
          DO P1=1,2
            DO P2=1,2
              DO P3=1,2
                IF(PHOTON) THEN
                  CP = G(I,P1)**2*G(ID(1),P2)*G(ID(2),P3)*Z34*Z56
     &                +G(I,P1)*EE(I)*G(ID(1),P2)*EE(ID(2))*Z34*P56
     &                +G(I,P1)*EE(I)*EE(ID(1))*G(ID(2),P3)*P34*Z56
     &                +EE(I)**2*EE(ID(1))*EE(ID(2))*P34*P56
                ELSE
                  CP = G(I,P1)**2*G(ID(1),P2)*G(ID(2),P3)*Z34*Z56
                ENDIF
                AMPT(I,P1,P2,P3) = ZAMP(4*P1+2*P3+P2-6)*CP
                TAMP = TAMP+AMPT(I,P1,P2,P3)*DCONJG(AMPT(I,P1,P2,P3))
              ENDDO
            ENDDO
          ENDDO
          AMP(I) = HALF*DBLE(TAMP)
        ENDDO
      ENDIF
C--Now calculate the cross section
      HCS = 0.0D0
      CFAC = CFAC1
      IF(ID(1).LE.2) CFAC = CFAC*THREE
      IF(ID(2).LE.2) CFAC = CFAC*THREE
      DO I=1,2
        DO I1=1,3
          IDP(1) = MAPZ(I,I1)
          IDP(2) = MAPZ(I,I1)+6
          DIST(1)=DISF(IDP(1),1)*DISF(IDP(2),2)
          DIST(2)=DISF(IDP(2),1)*DISF(IDP(1),2)
          DO I2=1,2
            HCS = HCS+CFAC*DIST(I2)*AMP(I)
            IF(GENEV.AND.HCS.GT.RCS) THEN
C--New for spin correlations
              IF(SYSPIN) THEN
                NSPN = 1
                DO 10 P1=1,2
                DO 10 P2=1,2
                DO 10 P3=1,2
                MESPN(P1,P2,P3,1,1,1) = AMPT(I,O(P1),O(P2),O(P3))
 10             MESPN(P1,P2,P3,2,1,1) = (0.0D0,0.0D0)
                NCFL(1) = 1
                SPNCFC(1,1,1) = ONE
              ENDIF
              GOTO 999
            ENDIF
          ENDDO
          IDP(1) = IDP(1)+6
          IDP(2) = IDP(2)-6
        ENDDO
      ENDDO
 999  RETURN
      END
